﻿//Astronomy Stacked Opacity using 100, 50, 33, 25, 20, 17, 14 etc.
//(100/N where N is which layer you’re on and N=1 is the base/background)
#target photoshop
app.bringToFront();
main();
function main(){
if(!documents.length) return;
var layerIDs = getLayerIDs();
try{
    activeDocument.backgroundLayer;
var S = 2; }catch(e){ var S = 1; };
for (var a =0;a < layerIDs.length;a++){
    setOpacity(Number(layerIDs[a]),(100/(a+S))); 
    }
}
function getLayerIDs(){ 
   var ref = new ActionReference(); 
   ref.putEnumerated( charIDToTypeID('Dcmn'), charIDToTypeID('Ordn'), charIDToTypeID('Trgt') ); 
   var count = executeActionGet(ref).getInteger(charIDToTypeID('NmbL')) +1; 
   var IDs=[];
try{
    activeDocument.backgroundLayer;
var i = 0; }catch(e){ var i = 1; };
   for(i;i<count;i++){ 
       if(i == 0) continue;
        ref = new ActionReference(); 
        ref.putIndex( charIDToTypeID( 'Lyr ' ), i );
        var desc = executeActionGet(ref);
        var layerName = desc.getString(charIDToTypeID( 'Nm  ' ));
        var Id = desc.getInteger(stringIDToTypeID( 'layerID' ));
        if(layerName.match(/^<\/Layer group/) ) continue;
        IDs.push(Id);
   }; 
return IDs;
};
function setOpacity(ID,Opacity) {
var ref = new ActionReference();
ref.putIdentifier(charIDToTypeID('Lyr '), ID);
var desc = new ActionDescriptor();
desc.putReference( charIDToTypeID('null'), ref );
var desc2 = new ActionDescriptor();
desc2.putUnitDouble( charIDToTypeID('Opct'), charIDToTypeID('#Prc'), Opacity);
desc.putObject( charIDToTypeID('T   '), charIDToTypeID('Lyr '), desc2 );
executeAction( charIDToTypeID('setd'), desc, DialogModes.NO );
};